#include <stdlib.h>
#include <stdio.h>
#include <windows.h>

struct pdb_header
{
  char name[32];
  char dummy1[28];
  char type[4];
  char dummy2[14];
  unsigned char addr[4];
  char dummy3[6];
};

/*
void convert(void* pnt, int size)
{
	unsigned char* p=(unsigned char*)pnt;
	unsigned char c;
	int i;

	for(i=0; i<size/2; i++)
	{
		c=p[i];
		p[i]=p[size-i-1];
		p[size-i-1]=c;
	}
}
*/
long fileSize(FILE * f)
{
	long oldPos=ftell(f);
	long newPos;

	fseek(f,0,SEEK_END);
	newPos=ftell(f);
	fseek(f,oldPos,SEEK_SET);
	return newPos;
}


int main(int argc, char* argv[])
{
	FILE * f1;
	FILE * f2;
	pdb_header head;
	long size,size2;
	unsigned char * bf;
	char fname2[512];

	if (argc<2)
	{
		printf("Usage:\npdb2pft <pdb-filename> [<pft-filename>]\n(c) Alexey Makhmutov (aka Lerm) 2004");
		return 0;
	}

	f1=fopen(argv[1],"rb");
	if (f1==NULL)
	{
		printf("Can't open file: %s!",argv[1]);
		return 1;
	}
	size=fileSize(f1);
	if (fread(&head,sizeof(head),1,f1)!=1)
	{
		fclose(f1);
		printf("Invalid format1: %s!",argv[1]);
		return 1;
	}
	//convert(&head.numRecords,2);
	if (head.type[0]!='F'&&head.type[0]!='f'||
		head.type[1]!='O'&&head.type[1]!='o'||
		head.type[2]!='N'&&head.type[2]!='n'||
		head.type[3]!='T'&&head.type[3]!='t')
	{
		fclose(f1);
		printf("Not a font!");
		return 1;
	}

	size2=size-sizeof(head);
	bf=new unsigned char[size2];
	fread(bf,1,size2,f1);
	fclose(f1);
	if (argc>2)
	{
		sprintf(fname2,"%s",argv[2]);
	}
	else
	{
		sprintf(fname2,"%s.pft",head.name);
	}

	f2=fopen(fname2,"wb");
	if (f2==NULL)
	{
		printf("Can't create file: %s!",fname2);
		delete [] bf;
		return 1;
	}
	fwrite(bf,1,size2,f2);
	fclose(f2);
	delete [] bf;
	return 0;
}